package cn.ischoolcode.javabook.scene9;

/* 
 * 爱校码
 * http://www.ischoolcode.cn/
 *  
 * @author zcj
 */

import java.util.*;

class EmptyListException extends RuntimeException{
    public EmptyListException(String name){
		super(name+"为空");
    }
 }
 class QueueDemo extends LinkedList{
    /**构建队列*/
    public QueueDemo(){
	super();
   }
   /**添加对象到队列*/
   public synchronized void enqueue(Object obj){
		offer(obj);
   }
   /**从队列中删除对象*/	
   public synchronized Object dequeue() throws EmptyListException{
		Object obj=null;
		try{
		 obj=remove();		 
		}
		catch(NoSuchElementException ex){
	       throw new EmptyListException("此队列");		
		}
		return obj;
	  }
 }
 public class QueueDemoTest {	 
   public static void main(String[] args) {
	QueueDemo queue=new QueueDemo();
		Boolean bool=Boolean.TRUE;
		Character character=new Character('￥');
		Integer integer=new Integer(4647);
		String string="hello";
		queue.enqueue(bool);
		System.out.println(queue+" "+bool+"已添加");
		queue.enqueue(character);
		System.out.println(queue+" "+character+"已添加");
		queue.enqueue(integer);
		System.out.println(queue+" "+integer+"已添加");
		queue.enqueue(string);
		System.out.println(queue+" "+string+"已添加");
		try{
			Object removeobj=null;
			while(true){
				removeobj=queue.dequeue();
				System.out.println(removeobj+"已删除");
			}
		}
		catch(EmptyListException ex){
			ex.printStackTrace();
		}
	 }
}